TITLE
     Datum Directory

AUTHOR
     Nader Sahib Eloshaiker

VERSION
     1.0 Build 22

NAME
     dd - dir program with ls command support and colored extensions

SYNOPSIS
     dd [-acdDEFhHlNOpqrRsStux1?] file1 file2 file3 ...
     dd file1 file2 file3 ... [-acdDEFhHlNOpqrsStux1?]
     dd file1 [-acdDEFhHlNOpqrsStux1?] file2 file3 ...
     dd file1 [-acdDEFhHlNOpqrsStux1?] file2 [-acdDEFhHlNOpqrsStux1?] file3 ...

DESCRIPTION
     DD  is  a  WIN32 console application written for the Microsoft  WIN32  sub
     system,   it will not however support the WIN32S subsystem.  DD  is  to  a
     degree  compatible with the UNIX directory program LS as  far  as  certain
     arguments are concerned. Current UNIX LS arguments supported are :

          [-acdFlqrRstux1]

     Work is still currently in  progress for the support  of the following
     remaining LS arguments are :

          [-CgiLo]

     Additional commands supported native to DD are:

          [-DEHNOSp?]

     There are two modes of display using DD. One is the short or brief listing
     the other is long or detailed. DD also supports pipes and output
     redirection. eg .

          [long format display]
          dd -l

          [short format display]
          dd   or   dd -ll
          (note "-l" flag toggles long display. "-ll" is a double toggle eg OFF
          -l ON -l OFF)

          [formatting pipes]
          dd |more       (page pause)

          [output redirection]
          dd >dirlist.txt     (dumps screen to a file called "dirlist.txt")

     DD  supports  both old MS-DOS style wildcards and new MS-DOS (UNIX)  style
     wildcards.  Multiple search conditions and wildcards are  permissible  and
     there is no limit on the number of search conditions specified. eg.

          [multiple search conditions]
               dd file1 file2 file3 ...
          [wildcard search parameters]
          dd *exe        (looks for files ending with "exe" for extensions and
          filenames)
          dd *.*e        (looks for files ending with "e" for extensions only)
          dd .*e         (as above looks for files ending with "e" for
          extensions only)
          dd e*.*        (looks for files starting with "exe")
          dd e*          (as above looks for files starting with "exe")
          dd *.e*        (looks for files starting with "e" for extensions
          only)
          dd .e*         (as above looks for files starting with "e" for
          extensions only)

     Arguments  maybe  passed  either via command prompt  or  via  the  COMMAND
     ENVIRONMENT.  If an argument is specified in the COMMAND ENVIRONMENT,  the
     argument  will be invoked every time DD is executed. Commands  passed  via
     the COMMAND ENVIRONMENT maybe be done as follows :

          set DD32CMD = -acdDEFlNOpqrRsStux1

     This  is set in either the AUTOEXEC.BAT, Windows NT Control Panel - SYSTEM
     or from the command prompt.

     Some  arguments will toggle so as to allow for deactivation if  preset  in
     the  COMMAND  ENVIRONMENT.  Commands  passed  via the command prompt maybe
     done as follows :

          dd [-acdDEFhHlNOpqrsStux1?] [-acdDEFhHlNOpqrsStux1?] ...

ARGUMENTS
     Arguments only applicable to short display format :
          s - Show Size (toggles)
          x - Sort files horizontally (toggles)
          1 - One column only (toggles)

     Arguments only applicable to long display format :
          l - Long display format (toggles)

     Arguments only applicable to both display format :
          a - All files (toggles)
          c - Use creation times
          d - Only display directories (toggles)
          F - Attach  "*" to executable's  "/" to directories  "@" to scripts
              (toggles)
          h - Help screen for commands pause maybe invoked aswell
          H - Help screen for color codes pause maybe invoked aswell
          O - Show DOS 8.3 filename formats (toggles)
          p - Pause (toggles)
          q - Replace non-printing chars as "?"(toggles)
          r - Reverse order of files (toggles)
          R - Recurse directory (toggles)
          t - Use last modified time
          u - Use last accessed time
          ? - Argument help screen

     Arguments used as sort conditions :
     Note  that  more than one condition maybe passed. The order in which  they
     are passed determines their priority
          D - Sort by date
          E - Sort by extension
          N - Sort by Name
          S - Sort by size

BUGS
     Currently  the  ownership  and so on that maybe  associated  with  network
     workspace has been excluded until Windows95 ships so that hopefully I  can
     then test the code under both OS. So far there isn't any specific NT calls
     but rather WIN32 so it should function correctly under Windows95.

COPYRIGHT
     This  program can be freely distributed and used as long as it is not sold
     or  made part of any commercial product. Use the program at your own risk,
     I take no responsibility for the program and its output.

AUTHOR
     Please  report  any  bugs  found or ideas to Mr  Nader  Eloshaiker.  Email
     [9172319@edna.swin.edu.au] or [U3917231@scrooge.ee.swin.edu.au]

